<?php
include "config.php" ;
include "master.php" ;
include "relay.php" ;
include "drivers.php" ;
include "drivers_custom.php" ;
include "functions.php" ;
include "output.php" ;

date_default_timezone_set( "Asia/Tokyo" ) ;

// check arguments
$datafile = "" ;
$savefile = "" ;
$isResume = FALSE ;
$data_hz = 60 ;
$skip = 0 ;
$data_udp = TRUE ;
if( array_key_exists("3", $argv ) ) {
  $datafile = $argv[1] ;
  $data_hz = $argv[2] ;
  $skip = $argv[3] ;

  if( !file_exists( $datafile ) ) {
    die() ;
  }
  if( $data_hz < 0 || $data_hz > 6000 ) {
    die() ;
  }
  if( $skip < 0 || $skip > 648000 ) {
    die() ;
  }
  $data_udp = FALSE ;
} elseif( array_key_exists("1", $argv ) ) {
  $savefile = $argv[1] ;
  if( !file_exists( $savefile ) ) {
    die() ;
  }
  $isResume = TRUE ;
}

// init data
$wDataMst = initWDataMst() ;

// create UDP socket
if( $data_udp ) {
  $sockRcv = socket_create( AF_INET, SOCK_DGRAM, SOL_UDP ) ;
  socket_bind( $sockRcv, $localhost, $listenPort ) ;
} else {
  $fpi = fopen( $datafile, "r" ) ;
  if( $skip > 0 ) {
    fseek( $fpi, $skip * $PACKET_SIZE ) ;
    if( feof($fpi) ) {
      die() ;
    }
  }
}

// open shared memory
$shmid = shmop_open( $SHM_ID, 'c', 0644, $SHM_SIZE ) ;
// main loop
echoTitle( $data_udp, $localhost, $listenPort, $datafile ) ;
if( $isResume ) {
  echo "resume session from $savefile\n" ;
}
$fpo = NULL ;
while( true ) {
  // create relay socket
  $sockSend = array() ;
  for( $i=0 ; $i<sizeof($relayList) ; $i++ ) {
    $sockSend[] = socket_create( AF_INET, SOCK_DGRAM, SOL_UDP ) ;
  }

  // sub loop
  for( $j=0 ; $j<300 ; $j++ ) {
//echo "s: " . microtime_float() . "\n" ;
    // recieve UDP
    if( $data_udp ) {
      $bytes = socket_recvfrom( $sockRcv, $buf, 4096, 0, $from, $port ) ;
    } else {
      if( !feof($fpi) ) {
        $buf = fread( $fpi, $PACKET_SIZE ) ;
        usleep( floor( 1000000 / $data_hz ) ) ;
      } else {
        fclose( $fpi ) ;
        break 2 ;
      }
    }
    $sz = strlen($buf) ;
    // bye
    if( $sz == strlen($PACKET_BYE) ) {
      if( strcmp($buf, $PACKET_BYE) == 0 ) {
        break 2 ;
      }
    }
    // illegal packet
    if( $sz != $PACKET_SIZE ) {
      break 2 ;
    }

    // relay
    for( $i=0 ; $i<sizeof($relayList) ; $i++ ) {
      $ip = getArray( $relayList[$i], 'ip' ) ;
      $port = getArray( $relayList[$i], 'port' ) ;
      if( $ip !=0 && $port != 0 ) {
        socket_sendto( $sockSend[$i], $buf, strlen($buf), 0, $ip, $port ) ;
      }
    }

    // unpack and extract
    $ud = unpack($UNPACK_FORMAT, $buf) ;
    $wData = getWData( $ud ) ;
    $cData = getCData( $ud, $CARS_MAX ) ;

    // main function
    if( $wData["m_track_number"] != $wDataMst["m_track_number"]  ||
        $wData["m_sessionType"] != $wDataMst["m_sessionType"] ||
        $wData["m_time"] < $wDataMst["m_time"]
    ) {
      // change track or change session or restart session
      if( $isResume ) {
        // resume session
        $isResume = FALSE ;
        $arr = unserialize( file_get_contents($savefile) ) ;
        $wDataMst = getArray( $arr, "wDataMst" ) ;
        $cDataMst = getArray( $arr, "cDataMst" ) ;
        if( sizeof($cDataMst) == $CARS_MAX ) {
          $wDataMst["m_time"] = $wData["m_time"] ;
          echo "resume success!\n" ;
        } else {
          echo "resume failed\n" ;
          startSession( $wData, $cData, $wDataMst, $cDataMst ) ;
        }
      } else {
        // start session
        startSession( $wData, $cData, $wDataMst, $cDataMst ) ;
      }
      $datestr = date("YmdHis") ;
      $track = $TRACKS[$wData["m_track_number"]] ;
      $st = $wData["m_sessionType"] ;
      $sid = substr( $SESSION_TYPE[$st], 0, 1 ) ;
      $savefile = sprintf( "data/%s_%s_%s.sav", $datestr, $track, $sid ) ;
      if( $data_udp && $isSaveData) {
        if( $fpo !== NULL ) {
          flush() ;
          fclose( $fpo ) ;
        }
        $tlmfile = sprintf( "data/%s_%s_%s.dat", $datestr, $track, $sid ) ;
        $fpo = fopen( $tlmfile, "w" ) ;
        stream_set_write_buffer( $fpo, $PACKET_SIZE * 5 ) ;
      }
/*
print_r( $cData ) ;
print_r( $cDataMst ) ;
*/
    }
    if( $wData["m_time"] >= $wDataMst["m_time"] ) {
      if( $data_udp && $isSaveData ) {
        fwrite( $fpo, $buf, strlen($buf) ) ;
      }
      // update status
      updateStatus( $shmid, $wData, $cData, $wDataMst, $cDataMst ) ;
    }

//echo "e: " . microtime_float() . "\n" ;
  }
  // close relay socket
  for( $i=0 ; $i<sizeof($relayList) ; $i++ ) {
    socket_close( $sockSend[$i] ) ;
  }
  // reload config
  reloadConfig( $wData, $cData, $cDataMst ) ;
}

// wait player
//echo "hit enter key to clear the browser screen\n" ;
echo "\nsave session data?(y/n):\n" ;
$buf = fgets( STDIN, 4096 ) ;
$c = substr( $buf, 0, 1 ) ;
if( strcmp($c,'y')==0 || strcmp($c,'Y')==0 ) {
  $arr = array(
    "wDataMst" => $wDataMst,
    "cDataMst" => $cDataMst,
  ) ;
  file_put_contents( $savefile, serialize($arr) ) ;
  echo "session data was saved to $savefile\n" ;
}
echo "\nbye\n" ;

// close
shmop_delete( $shmid ) ;
shmop_close( $shmid ) ;

if( $data_udp ) {
  socket_close( $sockRcv ) ;
  if( $isSaveData && $fpo !== NULL ) {
    fclose( $fpo ) ;
  }
}
?>
