<?php
include "daemon/master.php" ;
include "daemon/drivers.php" ;

function getName( $key ) {
  $retstr = "" ;
  if( array_key_exists( $key, $_POST ) ) {
    $str = preg_replace( '[^A-Z]', '', $_POST[$key] ) ;
    if( strlen($str) == 3 ) {
      $retstr = $str ;
    }
  }

  return $retstr ;
}

function getFlag( $key ) {
  $ret = 0 ;
  if( array_key_exists( $key, $_POST ) ) {
    $str = preg_replace( '[^0-9]', '', $_POST[$key] ) ;
    if( strlen($str) == 1 ) {
      $ret = $str ;
    }
  }

  return $ret ;
}

// get name from post data
$keys_list = array(
  "2017_9", "2017_15", "2017_0", "2017_6", "2017_16", "2017_22",
  "2017_3", "2017_35", "2017_5", "2017_33", "2017_10", "2017_20",
  "2017_1", "2017_23", "2017_7", "2017_14", "2017_2", "2017_34",
  "2017_18", "2017_31",
  "1980_23", "1980_1", "1980_16", "1980_68", "1980_2", "1980_3",
  "1980_24", "1980_4", "1980_20", "1980_6", "1980_9", "1980_18",
  "1980_22", "1980_10", "1980_8", "1980_14", "1980_31", "1980_7",
  "1980_0", "1980_5", "1980_15", "1980_32", "1980_33", "1980_34",
) ;
$reset = getFlag( "reset" ) ;
$post = getFlag( "post" ) ;
$switch = getFlag( "switch" ) ;

if( $post == 1 ) {
  $name_list = array() ;
  foreach( $keys_list as $key ) {
    $tmp = explode( "_", $key ) ;
    $i0 = $tmp[0] ;
    $i1 = $tmp[1] ;
    $name = getName($key) ;
    if( strlen($name) == 3 && $reset == 0 ) {
      $name_list[$i0][$i1] = $name ;
    } else {
      $name_list[$i0][$i1] = $DRIVERS[$i0][$i1][1] ;
    }
  }

  ob_start() ;
  echo "<?php\n" ;
  echo "global \$DRIVERS_CUSTOM, \$USE_DRIVERS_CUSTOM ; \n" ;
  echo "\$USE_DRIVERS_CUSTOM = $switch ;\n" ;
  echo "\$DRIVERS_CUSTOM = array(\n" ;
  foreach( $name_list as $i0 => $sub ) {
    echo "  $i0 => array(\n" ;
    foreach( $sub as $i1 => $name ) {
      echo "    $i1 => array( \"\", \"$name\" ),\n" ;
    }
    echo "  ),\n" ;
  }
  echo ");\n" ;
  echo "?>\n" ;
  $data = ob_get_contents() ;
  ob_end_clean() ;

  // write
  $ret = file_put_contents( "daemon/drivers_custom.php", $data, LOCK_EX ) ;
}

// read
$fp = fopen( "daemon/drivers_custom.php", "r" ) ;
flock( $fp, LOCK_SH ) ;
include "daemon/drivers_custom.php" ;
fclose( $fp ) ;

$checked = "" ;
if( $USE_DRIVERS_CUSTOM == 1 ) {
  $checked = "checked" ;
}
?>
<html>
<head>
  <meta http-equiv="content-type" content="text/html; charset=utf-8">
  <meta http-equiv="Pragma" content="no-cache">
  <meta http-equiv="Cache-Control" content="no-store">
  <meta http-equiv="Cache-Control" content="no-cache">
  <meta http-equiv="Expires" content="-1">
  <link rel="stylesheet" type="text/css" href="common.css">
  <title>Driver Settings - <?php echo $PGNAME; ?></title>
</head>
<body>
  </form>
  <form method="post" action="settings.php">
    <input type="hidden" name="post" value="1">
    <table border="1">
      <tr>
        <td width="150"><input type="checkbox" name="switch" value="1" <?php echo $checked ; ?>>Use Custom</td>
        <td width="150"><input type="checkbox" name="reset" value="1">Reset</td>
        <td><input type="submit" value="Save"></td>
      </tr>
    </table>
    <hr />
<?php
foreach( $DRIVERS as $era => $list ) {
  if( $era == 2017 || $era == 1980 ) {
?>
    <h2><?php echo $era; ?></h2>
    <table border="1">
<?php
    foreach( $list as $idx => $data ) {
      $custom = $DRIVERS_CUSTOM[$era][$idx][1] ;
?>
      <tr align="left">
        <td width="200"><?php echo $data[0] ; ?></td>
        <td width="50"><?php echo $data[1] ; ?></td>
        <td><input type="text" name="<?php printf("%s_%s", $era, $idx); ?>" size="5" maxlength="3" value="<?php echo $custom; ?>"></td>
      </tr>
<?php
    }
?>
<?php
  }
?>
    </table>
<?php
}
?>
    <br />
  </form>
</body>
</html>
